feat: fivebyeight framework

main
Sean McBride 4 years ago
parent 2115df8c94
commit e6696e93c9

@ -1,19 +0,0 @@
#!/bin/bash
# Executes the runtime in GDB
# Substitutes the absolute path from the container with a path relatively derived from the location of this script
# This allows debugging outside of the Docker container
# Also disables pagination and stopping on SIGUSR1
experiment_directory=$(pwd)
project_directory=$(cd ../../../.. && pwd)
binary_directory=$(cd "$project_directory"/bin && pwd)
export LD_LIBRARY_PATH="$binary_directory:$LD_LIBRARY_PATH"
export PATH="$binary_directory:$PATH"
gdb --eval-command="handle SIGUSR1 nostop" \
--eval-command="handle SIGPIPE nostop" \
--eval-command="set pagination off" \
--eval-command="set substitute-path /sledge/runtime $project_directory" \
--eval-command="run $experiment_directory/spec.json" \
sledgert

@ -0,0 +1,3 @@
SLEDGE_SCHEDULER=EDF
SLEDGE_DISABLE_PREEMPTION=true
SLEDGE_NWORKERS=1

@ -0,0 +1,4 @@
SLEDGE_SCHEDULER=EDF
SLEDGE_DISABLE_PREEMPTION=false
SLEDGE_SIGALRM_HANDLER=TRIAGED
SLEDGE_NWORKERS=1

@ -0,0 +1,3 @@
SLEDGE_SCHEDULER=FIFO
SLEDGE_DISABLE_PREEMPTION=true
SLEDGE_NWORKERS=1

@ -0,0 +1,3 @@
SLEDGE_SCHEDULER=FIFO
SLEDGE_DISABLE_PREEMPTION=false
SLEDGE_NWORKERS=1

@ -1,73 +1,65 @@
#!/bin/bash #!/bin/bash
# Executes the runtime in GDB
# Substitutes the absolute path from the container with a path relatively derived from the location of this script
# This allows debugging outside of the Docker container
# Also disables pagination and stopping on SIGUSR1
experiment_directory=$(pwd) __run_sh__base_path="$(dirname "$(realpath --logical "${BASH_SOURCE[0]}")")"
echo "$experiment_directory" __run_sh__bash_libraries_relative_path="../../../bash_libraries"
project_directory=$(cd ../../../.. && pwd) __run_sh__bash_libraries_absolute_path=$(cd "$__run_sh__base_path" && cd "$__run_sh__bash_libraries_relative_path" && pwd)
binary_directory=$(cd "$project_directory"/bin && pwd) export PATH="$__run_sh__bash_libraries_absolute_path:$PATH"
did_pass=true source csv_to_dat.sh || exit 1
source framework.sh || exit 1
source get_result_count.sh || exit 1
source panic.sh || exit 1
source path_join.sh || exit 1
if [ "$1" != "-d" ]; then # Validate that required tools are in path
PATH="$binary_directory:$PATH" LD_LIBRARY_PATH="$binary_directory:$LD_LIBRARY_PATH" sledgert "$experiment_directory/spec.json" & declare -a required_binaries=(curl)
sleep 1 validate_dependencies() {
else for required_binary in "${required_binaries[@]}"; do
echo "Running under gdb" if ! command -v "$required_binary" > /dev/null; then
fi echo "$required_binary is not present." >> "$results_directory/results.txt"
exit 1
fi
done
}
expected_result="$(cat ./expected_result.txt)" experiment_main() {
local -r hostname="$1"
local -r results_directory="$2"
# Retry 5 times in case the runtime startup is slow sleep 2
retries=5
for ((i = 0; i < retries; i++)); do
result=$(curl -H 'Expect:' -H "Content-Type: text/plain" --data-binary "@5x8.pnm" localhost:10000 2> /dev/null)
if [[ "$result" == "$expected_result" ]]; then
break
fi
if ((i == 4)); then validate_dependencies
echo "Retries exhaused"
exit 1
fi
sleep 1 local -r expected_result="$(cat ./expected_result.txt)"
done
success_count=0 local -i success_count=0
total_count=50 local -ir total_count=10
for ((i = 0; i < total_count; i++)); do for ((i = 0; i < total_count; i++)); do
result=$(curl -H 'Expect:' -H "Content-Type: text/plain" --data-binary "@5x8.pnm" localhost:10000 2> /dev/null) result=$(curl -H 'Expect:' -H "Content-Type: text/plain" --data-binary "@5x8.pnm" "$hostname:10000" 2> /dev/null)
# echo "$result" if [[ "$result" == "$expected_result" ]]; then
if [[ "$result" == "$expected_result" ]]; then success_count=$((success_count + 1))
success_count=$((success_count + 1)) else
else {
echo "FAIL" echo "FAIL"
echo "Expected:" echo "Expected:"
echo "$expected_result" echo "$expected_result"
echo "===============================================" echo "==============================================="
echo "Was:" echo "Was:"
echo "$result" echo "$result"
} >> "$results_directory/results.txt"
break
fi
done
did_pass=false echo "$success_count / $total_count" >> "$results_directory/results.txt"
break
fi
done
echo "$success_count / $total_count" if ((success_count == total_count)); then
return 0
else
return 1
fi
if [ "$1" != "-d" ]; then }
sleep 5
echo -n "Running Cleanup: "
pkill sledgert > /dev/null 2> /dev/null
echo "[DONE]"
fi
if $did_pass; then main "$@"
exit 0
else
exit 1
fi

Loading…
Cancel
Save